#include "Ethernet_Demo_objects.h"
#include "Ethernet_Demo_resources.h"

//--------------------- User code ---------------------//
#include        "__Ethernet.h"                           //Librera de Ethernet externa.
/************************************************************
 * ROM constant strings
 */
const code unsigned char httpHeader[] = "HTTP/1.1 200 OK\nContent-type: ";  // HTTP header
const code unsigned char httpMimeTypeHTML[] = "text/html\n\n";              // HTML MIME type
const code unsigned char httpMimeTypeScript[] = "text/plain\n\n";           // TEXT MIME type
unsigned char httpMethod[] = "GET /";
/*
 * web page, splited into 2 parts :
 * when coming short of ROM, fragmented data is handled more efficiently by linker
 *
 * this HTML page calls the boards to get its status, and builds itself with javascript
 */
const code   char    *indexPage =                   // Change the IP address of the page to be refreshed

//refresh actualiza automticamente su contenido. URL es el IP de la pgina.

"<meta http-equiv=\"refresh\" content=\"3;url=http://192.168.20.60\">\
<HTML><HEAD></HEAD><BODY>\
<h1>PIC32 Ethernet Mini Web Server</h1>\
<a href=/>Reload</a>\
<script src=/s></script>\
<table><tr><td valign=top>\
</td><td>\
" ;

const code   char    *indexPage2 =  "</td><td>\
<table border=1 style=\"font-size:20px ;font-family: terminal ;\">\
<tr><th colspan=3>LED</th></tr>\
<script>\
var str,i;\
str=\"\";\
for(i=0;i<8;i++)\
{str+=\"<tr><td bgcolor=yellow>LED #\"+i+\"</td>\";\
if(PORTD&(1<<i)){str+=\"<td bgcolor=red>ON\";}\
else {str+=\"<td bgcolor=#cccccc>OFF\";}\
str+=\"</td><td><a href=/t\"+i+\">Toggle</a></td></tr>\";}\
document.write(str) ;\
</script>\
</table></td></tr></table>\
This is HTTP request #<script>document.write(REQ)</script></BODY></HTML>\
" ;


//Direcciones IP - Deben coincidir con la computadora.
unsigned char   myMacAddr[6] = {0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f};   // my MAC address
unsigned char   myIpAddr[4]  = {192, 168,  20, 60 };                   // my IP address
unsigned char   gwIpAddr[4]  = {192, 168,  20,  6 };                   // gateway (router) IP address
unsigned char   ipMask[4]    = {255, 255, 255,  0 };                   // network mask (for example : 255.255.255.0)
unsigned char   dnsIpAddr[4] = {192, 168,  20,  1 };                   // DNS server IP address

unsigned char   getRequest[15];                                        // HTTP request buffer
unsigned char   dyna[31] ;                                             // buffer for dynamic response
unsigned long   httpCounter = 0;                                       // counter of HTTP requests

unsigned int    Ethernet_UserUDP(unsigned char *remoteHost, unsigned int remotePort, unsigned int destPort, unsigned int reqLength, TEthPktFlags *flags)
        {
        unsigned int    len;                           // my reply length

        // reply is made of the remote host IP address in human readable format
        ByteToStr(remoteHost[0], dyna);                // first IP address byte
        dyna[3] = '.';
        ByteToStr(remoteHost[1], dyna + 4);            // second
        dyna[7] = '.';
        ByteToStr(remoteHost[2], dyna + 8);            // third
        dyna[11] = '.';
        ByteToStr(remoteHost[3], dyna + 12);           // fourth

        dyna[15] = ':';                                // add separator

        // then remote host port number
        WordToStr(remotePort, dyna + 16);
        dyna[21] = '[';
        WordToStr(destPort, dyna + 22);
        dyna[27] = ']';
        dyna[28] = 0;

        // the total length of the request is the length of the dynamic string plus the text of the request
        len = 28 + reqLength;

        // puts the dynamic string into the transmit buffer
        Ethernet_putBytes(dyna, 28);

        // then puts the request string converted into upper char into the transmit buffer
        while(reqLength--)
                {
                Ethernet_putByte(toupper(Ethernet_getByte()));
                }

        return(len);           // back to the library with the length of the UDP reply
        }


char CircleColor = 0;

void TogleCircle(TCircle *Acircle){
  if(Acircle->color == CL_WHITE)
    Acircle->color = CL_RED;
  else
    Acircle->color = CL_WHITE;
  DrawCircle(Acircle);
}

void ToggleC(char num){
char cc;
  switch(num){
    case 0 : TogleCircle(&Circle1); break;
    case 1 : TogleCircle(&Circle2); break;
    case 2 : TogleCircle(&Circle3); break;
    case 3 : TogleCircle(&Circle4); break;
    case 4 : TogleCircle(&Circle5); break;
    case 5 : TogleCircle(&Circle6); break;
    case 6 : TogleCircle(&Circle7); break;
    case 7 : TogleCircle(&Circle8); break;
  }
  cc = 1 << num;
  CircleColor = CircleColor ^ cc;
}


unsigned int    Ethernet_UserTCP(unsigned char *remoteHost, unsigned int remotePort, unsigned int localPort, unsigned int reqLength, TEthPktFlags *flags)
        {
        unsigned int    len;            // my reply length

        // should we close tcp socket after response is sent?
        // library closes tcp socket by default if canCloseTCP flag is not reset here
        // flags->canCloseTCP = 0; // 0 - do not close socket
                                   // otherwise - close socket

        if(localPort != 80)                         // I listen only to web request on port 80
                {
                return(0);
                }

        // get 10 first bytes only of the request, the rest does not matter here
        for(len = 0; len < 10; len++)
        {
        getRequest[len] = Ethernet_getByte();
        }
        getRequest[len] = 0;
        len = 0;

        if(memcmp(getRequest, httpMethod, 5))       // only GET method is supported here
                {
                return(0);
                }

        httpCounter++;                             // one more request done

        //Cuerpo del programa de la pgina de Internet.
        //
        if(getRequest[5] == 's')                    // if request path name starts with s, store dynamic data in transmit buffer
                {
                // the text string replied by this request can be interpreted as javascript statements
                // by browsers

                len = Ethernet_putConstString(httpHeader);              // HTTP header
                len += Ethernet_putConstString(httpMimeTypeScript);     // with text MIME type

                // add PORTD value (LEDs) to reply
                len += Ethernet_putConstString("var PORTD=");
                WordToStr(CircleColor, dyna);
                len += Ethernet_putString(dyna);
                len += Ethernet_putConstString(";");

                // add HTTP requests counter to reply
                WordToStr(httpCounter, dyna);
                len += Ethernet_putConstString("var REQ=");
                len += Ethernet_putString(dyna);
                len += Ethernet_putConstString(";");
                }
                
        //Al presionar un botn, se ejecutan las acciones aqu indicadas.
        else if(getRequest[5] == 't')                           // if request path name starts with t, toggle PORTD (LED) bit number that comes after
                {
                unsigned long   bitMask = 0;                   // for bit mask

                if(isdigit(getRequest[6]))                      // if 0 <= bit number <= 9, bits 8 & 9 does not exist but does not matter
                        {
                        bitMask = getRequest[6] - '0';         // convert ASCII to integer
                        ToggleC(bitMask);
                        }
                }

        if(len == 0)                                            // what do to by default
                {
                len =  Ethernet_putConstString(httpHeader);             // HTTP header
                len += Ethernet_putConstString(httpMimeTypeHTML);       // with HTML MIME type
                len += Ethernet_putConstString(indexPage);              // HTML page first part
                len += Ethernet_putConstString(indexPage2);             // HTML page second part
                }

        return(len);                                           // return to the library with the number of bytes to transmit
        }

void InitPHYPins(){
  TRISD11_bit = 0;   // ETH_ALT_MDC_BIT
  TRISD8_bit = 1;    // ETH_ALT_MDIO_BIT

  TRISA15_bit = 0;   // ETH_ALT_TXEN_BIT
  TRISD14_bit = 0;   // ETH_ALT_TXD0_BIT
  TRISD15_bit = 0;   // ETH_ALT_TXD1_BIT

  TRISG9_bit = 1;    // ETH_ALT_RXCLK_BIT
  TRISG8_bit = 1;    // ETH_ALT_RXDV_BIT
  TRISE8_bit = 1;    // ETH_ALT_RXD0_BIT
  TRISE9_bit = 1;    // ETH_ALT_RXD1_BIT
  TRISG15_bit = 1;   // ETH_ALT_RXERR_BIT
}
//----------------- End of User code ------------------//

// Event Handlers




void Circle1Click() {
  TogleCircle(&Circle1);
  CircleColor = CircleColor ^ (1 << 0);
}

void Circle2Click() {
  TogleCircle(&Circle2);
  CircleColor = CircleColor ^ (1 << 1);
}

void Circle3Click() {
  TogleCircle(&Circle3);
  CircleColor = CircleColor ^ (1 << 2);
}

void Circle4Click() {
  TogleCircle(&Circle4);
  CircleColor = CircleColor ^ (1 << 3);
}

void Circle5Click() {
  TogleCircle(&Circle5);
  CircleColor = CircleColor ^ (1 << 4);
}

void Circle6Click() {
  TogleCircle(&Circle6);
  CircleColor = CircleColor ^ (1 << 5);
}

void Circle7Click() {
  TogleCircle(&Circle7);
  CircleColor = CircleColor ^ (1 << 6);
}

void Circle8Click() {
  TogleCircle(&Circle8);
  CircleColor = CircleColor ^ (1 << 7);
}